package com.xynet.marketing.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Objects;

public class AESUtil {
    protected static final Logger logger = LoggerFactory.getLogger(AESUtil.class);
    public static void main(String[] args) {
        String data = "7udmY6IFu0:1589622062:1";
        String key = "3152BCC2109A8E405BC1BE0A53D22350";
        //String machineid = "888888";
        String encrypt = Objects.requireNonNull(encrypt(data, key)).toLowerCase();
        System.out.println("加密前：" + data);
        System.out.println("加密后：" + encrypt);
        //String[] cmds = {"curl", "-H", "Host: https://payapi.weixiao.qq.com/", "-H", "authorization: WxToken : " + machineid + encrypt, "-H", "Cache-Control: max-age=0", "--compressed", "https://payapi.weixiao.qq.com/config_v2"};
        //execCurl(cmds);
    }

    public static String encrypt(String data, String key) {

        String ivString = key.substring(0,16);
        //偏移量
        byte[] iv = ivString.getBytes();
        try {
            Cipher cipher = Cipher.getInstance("AES/CFB/NoPadding");
            int blockSize = cipher.getBlockSize();
            byte[] dataBytes = data.getBytes();
            int length = dataBytes.length;
            //计算需填充长度

            byte[] plaintext = new byte[length];
            //填充
            System.arraycopy(dataBytes, 0, plaintext, 0, dataBytes.length);
            SecretKeySpec keySpec = new SecretKeySpec(key.getBytes(), "AES");
            logger.info("key="+keySpec.toString());
            //设置偏移量参数
            IvParameterSpec ivSpec = new IvParameterSpec(iv);
            logger.info("iv="+iv.toString());
            cipher.init(Cipher.ENCRYPT_MODE, keySpec, ivSpec);
            byte[] encryped = cipher.doFinal(plaintext);

            return parseByte2HexStr(encryped);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return null;
        }

    }

    public static String parseByte2HexStr(byte[] buf) {
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < buf.length; ++i) {
            String hex = Integer.toHexString(buf[i] & 255);
            if (hex.length() == 1) {
                hex = '0' + hex;
            }
            sb.append(hex.toUpperCase());
        }

        return sb.toString();
    }



    public static String execCurl(String[] cmds) {
        ProcessBuilder process = new ProcessBuilder(cmds);
        Process p;
        try {
            p = process.start();
            BufferedReader reader = new BufferedReader(new InputStreamReader(p.getInputStream()));
            StringBuilder builder = new StringBuilder();
            String line = null;
            while ((line = reader.readLine()) != null) {
                builder.append(line);
                builder.append(System.getProperty("line.separator"));
            }
            return builder.toString();

        } catch (IOException e) {
            System.out.print("error");
            e.printStackTrace();
        }
        return null;
    }

}