package com.xynet.marketing.utils.error;


/**
 * 通用终止异常
 */
public class BusinessException extends RuntimeException {

    public BusinessException(String message) {
        super(message);
    }

    public BusinessException(Integer status, String message) {
        super(String.format("%d::%s", status, message));
    }

    public BusinessException(Throwable e) {
        super(e);
    }

    public BusinessException(String msg, Throwable cause) {
        super(msg, cause);
    }


}
